# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.location import Location  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.xhtml_node import XhtmlNode  # noqa: F401,E501


class XhtmlNode(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'location': 'Location',
        'node_type': 'str',
        'name': 'str',
        'attributes': 'dict(str, str)',
        'child_nodes': 'list[XhtmlNode]',
        'content': 'str',
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'value_as_string': 'str',
        'first_element': 'XhtmlNode',
        'ns_decl': 'str',
        'no_pretty': 'bool',
        'para': 'bool',
        'empty': 'bool',
        'value': 'str'
    }

    attribute_map = {
        'location': 'location',
        'node_type': 'nodeType',
        'name': 'name',
        'attributes': 'attributes',
        'child_nodes': 'childNodes',
        'content': 'content',
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'value_as_string': 'valueAsString',
        'first_element': 'firstElement',
        'ns_decl': 'nsDecl',
        'no_pretty': 'noPretty',
        'para': 'para',
        'empty': 'empty',
        'value': 'value'
    }

    def __init__(self, location=None, node_type=None, name=None, attributes=None, child_nodes=None, content=None, format_comments_pre=None, format_comments_post=None, value_as_string=None, first_element=None, ns_decl=None, no_pretty=None, para=None, empty=None, value=None):  # noqa: E501
        """XhtmlNode - a model defined in Swagger"""  # noqa: E501

        self._location = None
        self._node_type = None
        self._name = None
        self._attributes = None
        self._child_nodes = None
        self._content = None
        self._format_comments_pre = None
        self._format_comments_post = None
        self._value_as_string = None
        self._first_element = None
        self._ns_decl = None
        self._no_pretty = None
        self._para = None
        self._empty = None
        self._value = None
        self.discriminator = None

        if location is not None:
            self.location = location
        if node_type is not None:
            self.node_type = node_type
        if name is not None:
            self.name = name
        if attributes is not None:
            self.attributes = attributes
        if child_nodes is not None:
            self.child_nodes = child_nodes
        if content is not None:
            self.content = content
        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if value_as_string is not None:
            self.value_as_string = value_as_string
        if first_element is not None:
            self.first_element = first_element
        if ns_decl is not None:
            self.ns_decl = ns_decl
        if no_pretty is not None:
            self.no_pretty = no_pretty
        if para is not None:
            self.para = para
        if empty is not None:
            self.empty = empty
        if value is not None:
            self.value = value

    @property
    def location(self):
        """Gets the location of this XhtmlNode.  # noqa: E501


        :return: The location of this XhtmlNode.  # noqa: E501
        :rtype: Location
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this XhtmlNode.


        :param location: The location of this XhtmlNode.  # noqa: E501
        :type: Location
        """

        self._location = location

    @property
    def node_type(self):
        """Gets the node_type of this XhtmlNode.  # noqa: E501


        :return: The node_type of this XhtmlNode.  # noqa: E501
        :rtype: str
        """
        return self._node_type

    @node_type.setter
    def node_type(self, node_type):
        """Sets the node_type of this XhtmlNode.


        :param node_type: The node_type of this XhtmlNode.  # noqa: E501
        :type: str
        """
        allowed_values = ["Element", "Text", "Comment", "DocType", "Document", "Instruction"]  # noqa: E501
        if node_type not in allowed_values:
            raise ValueError(
                "Invalid value for `node_type` ({0}), must be one of {1}"  # noqa: E501
                .format(node_type, allowed_values)
            )

        self._node_type = node_type

    @property
    def name(self):
        """Gets the name of this XhtmlNode.  # noqa: E501


        :return: The name of this XhtmlNode.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this XhtmlNode.


        :param name: The name of this XhtmlNode.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def attributes(self):
        """Gets the attributes of this XhtmlNode.  # noqa: E501


        :return: The attributes of this XhtmlNode.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """Sets the attributes of this XhtmlNode.


        :param attributes: The attributes of this XhtmlNode.  # noqa: E501
        :type: dict(str, str)
        """

        self._attributes = attributes

    @property
    def child_nodes(self):
        """Gets the child_nodes of this XhtmlNode.  # noqa: E501


        :return: The child_nodes of this XhtmlNode.  # noqa: E501
        :rtype: list[XhtmlNode]
        """
        return self._child_nodes

    @child_nodes.setter
    def child_nodes(self, child_nodes):
        """Sets the child_nodes of this XhtmlNode.


        :param child_nodes: The child_nodes of this XhtmlNode.  # noqa: E501
        :type: list[XhtmlNode]
        """

        self._child_nodes = child_nodes

    @property
    def content(self):
        """Gets the content of this XhtmlNode.  # noqa: E501


        :return: The content of this XhtmlNode.  # noqa: E501
        :rtype: str
        """
        return self._content

    @content.setter
    def content(self, content):
        """Sets the content of this XhtmlNode.


        :param content: The content of this XhtmlNode.  # noqa: E501
        :type: str
        """

        self._content = content

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this XhtmlNode.  # noqa: E501


        :return: The format_comments_pre of this XhtmlNode.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this XhtmlNode.


        :param format_comments_pre: The format_comments_pre of this XhtmlNode.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this XhtmlNode.  # noqa: E501


        :return: The format_comments_post of this XhtmlNode.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this XhtmlNode.


        :param format_comments_post: The format_comments_post of this XhtmlNode.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def value_as_string(self):
        """Gets the value_as_string of this XhtmlNode.  # noqa: E501


        :return: The value_as_string of this XhtmlNode.  # noqa: E501
        :rtype: str
        """
        return self._value_as_string

    @value_as_string.setter
    def value_as_string(self, value_as_string):
        """Sets the value_as_string of this XhtmlNode.


        :param value_as_string: The value_as_string of this XhtmlNode.  # noqa: E501
        :type: str
        """

        self._value_as_string = value_as_string

    @property
    def first_element(self):
        """Gets the first_element of this XhtmlNode.  # noqa: E501


        :return: The first_element of this XhtmlNode.  # noqa: E501
        :rtype: XhtmlNode
        """
        return self._first_element

    @first_element.setter
    def first_element(self, first_element):
        """Sets the first_element of this XhtmlNode.


        :param first_element: The first_element of this XhtmlNode.  # noqa: E501
        :type: XhtmlNode
        """

        self._first_element = first_element

    @property
    def ns_decl(self):
        """Gets the ns_decl of this XhtmlNode.  # noqa: E501


        :return: The ns_decl of this XhtmlNode.  # noqa: E501
        :rtype: str
        """
        return self._ns_decl

    @ns_decl.setter
    def ns_decl(self, ns_decl):
        """Sets the ns_decl of this XhtmlNode.


        :param ns_decl: The ns_decl of this XhtmlNode.  # noqa: E501
        :type: str
        """

        self._ns_decl = ns_decl

    @property
    def no_pretty(self):
        """Gets the no_pretty of this XhtmlNode.  # noqa: E501


        :return: The no_pretty of this XhtmlNode.  # noqa: E501
        :rtype: bool
        """
        return self._no_pretty

    @no_pretty.setter
    def no_pretty(self, no_pretty):
        """Sets the no_pretty of this XhtmlNode.


        :param no_pretty: The no_pretty of this XhtmlNode.  # noqa: E501
        :type: bool
        """

        self._no_pretty = no_pretty

    @property
    def para(self):
        """Gets the para of this XhtmlNode.  # noqa: E501


        :return: The para of this XhtmlNode.  # noqa: E501
        :rtype: bool
        """
        return self._para

    @para.setter
    def para(self, para):
        """Sets the para of this XhtmlNode.


        :param para: The para of this XhtmlNode.  # noqa: E501
        :type: bool
        """

        self._para = para

    @property
    def empty(self):
        """Gets the empty of this XhtmlNode.  # noqa: E501


        :return: The empty of this XhtmlNode.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this XhtmlNode.


        :param empty: The empty of this XhtmlNode.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def value(self):
        """Gets the value of this XhtmlNode.  # noqa: E501


        :return: The value of this XhtmlNode.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this XhtmlNode.


        :param value: The value of this XhtmlNode.  # noqa: E501
        :type: str
        """

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, XhtmlNode):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
